--Krone BigM
--extends vehicle.lua
--by Sven777b 09/08
-- GrasMod compatible
-- Convert to LS2009 by LAUTSCHREIER
-- @date 08/01/10

BigM1 = {};

function BigM1.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function BigM1:load(xmlFile)
 self.groundReferenceThreshold = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.groundReferenceNode#threshold"), 0.2);
    self.groundReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundReferenceNode#index"));
    if self.groundReferenceNode == nil then
        self.groundReferenceNode = self.components[1].node;
    end;
   
 
								
    local numCuttingElements = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingElements#count"), 0);
    self.cuttingElements = {};
    for i=1, numCuttingElements do
      local partnamei = string.format("vehicle.cuttingElements.element" .. "%d", i);
      self.cuttingElements[i] = {};
      self.cuttingElements[i].index = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
      local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#minRot"));
      self.cuttingElements[i].minRot = {};
      self.cuttingElements[i].minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.cuttingElements[i].minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.cuttingElements[i].minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#medRot"));
      self.cuttingElements[i].medRot = {};
      self.cuttingElements[i].medRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.cuttingElements[i].medRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.cuttingElements[i].medRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, partnamei .. "#maxRot"));
      self.cuttingElements[i].maxRot = {};
      self.cuttingElements[i].maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
      self.cuttingElements[i].maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
      self.cuttingElements[i].maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
      self.cuttingElements[i].rotSpeed = Utils.getNoNil(getXMLString(xmlFile,  partnamei .. "#rotSpeed"), 2)*1000;
      self.cuttingElements[i].area = Utils.getNoNil(getXMLInt(xmlFile,  partnamei .. "#cuttingArea"), 1);
      self.cuttingElements[i].getDown = false;
      self.cuttingElements[i].lift = true;
      self.cuttingElements[i].isDown = false;
    end;
    local numCuttingAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingAreas#count"), 0);
    
    local numCuttingAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingAreas#count"), 0);
    for i=1, numCuttingAreas do
        local areanamei = string.format("vehicle.cuttingAreas.cuttingArea%d", i);
        self.cuttingAreas[i].foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMinLimit"), 0);
        self.cuttingAreas[i].foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMaxLimit"), 1);
    end;
	
	self.keys = {};
local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
    
   

self.numWalzen = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.walzen#count"), 0); 
 self.walzen = {}; 
 for i=1, self.numWalzen do 
     local partnamei = string.format("vehicle.walzen.part" .. "%d", i); 
     self.walzen[i] = {}; 
     self.walzen[i].index = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei.."#index")); 
     self.walzen[i].speed = Utils.getNoNil(getXMLInt(xmlFile, partnamei.."#rotSpeed"), 1); 
 end; 

    self.wasToFast = false;
    self.allDown = false;
    self.Mower = false;
    self.swath = false;
    
  local mowerSound = getXMLString(xmlFile, "vehicle.mowerSound#file");
    if mowerSound ~= nil and mowerSound ~= "" then
        mowerSound = Utils.getFilename(mowerSound, self.baseDirectory); 
        self.mowerSound = createSample("mowerSound");
        self.mowerSoundEnabled = false;
        loadSample(self.mowerSound, mowerSound, false);
        self.mowerSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowerSound#pitchOffset"), 1);
        self.mowerSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowerSound#volume"), 1);
    end;


    
end;


function BigM1:keyEvent(unicode, sym, modifier, isDown)
  

    if isDown and sym == self.keys.transport then
      self.allDown = not self.allDown;
      for i=1, table.getn(self.cuttingElements) do
        self.cuttingElements[i].getDown = self.allDown;
      end;
    end;
    
    if isDown and sym == self.keys.maehen then
		if self.allDown then
			self.Mower = not self.Mower;
		end
    end;

    if isDown and sym == self.keys.heben_links then
      self.cuttingElements[2].lift = not self.cuttingElements[2].lift;
    end;

    if isDown and sym == self.keys.heben_rechts then
      self.cuttingElements[3].lift = not self.cuttingElements[3].lift;
    end;

    if isDown and sym == self.keys.heben_vorn then
      self.cuttingElements[1].lift = not self.cuttingElements[1].lift;
    end;

    if isDown and sym == self.keys.schwaden then
		if self.Mower then
			self.swath = not self.swath;
		end
    end;




end;

function BigM1:update(dt)





    --if self.isEntered then
        self.wasToFast = false;
        if self.Mower then 
            self.wasToFast = self.lastSpeed*3600 > 20;
        end;
        local meadow = 0;
        for i=1,table.getn(self.cuttingElements) do
        
            self.cuttingElements[i].isDown = self.cuttingElements[i].isDown and self.allDown;
            self.cuttingElements[i].onGround = false;
            local x, y, z = getRotation(self.cuttingElements[i].index);
            local rot = {x,y,z};
            local minRot = self.cuttingElements[i].minRot;
            local medRot = self.cuttingElements[i].medRot;
            local maxRot = self.cuttingElements[i].maxRot;

            if math.abs(x - medRot[1]) < 0.001 and math.abs(y - medRot[2]) < 0.001 and math.abs(z - medRot[3]) < 0.001 then
                self.cuttingElements[i].isDown = true;
            end;
            if math.abs(x - maxRot[1]) < 0.001 and math.abs(y - maxRot[2]) < 0.001 and math.abs(z - maxRot[3]) < 0.001 then
                self.cuttingElements[i].onGround = true;
            end;

            local newRot = Utils.getMovedLimitedValues(rot, medRot, minRot, 3, self.cuttingElements[i].rotSpeed, dt, not self.allDown);
            if self.cuttingElements[i].isDown and self.allDown then
                newRot = Utils.getMovedLimitedValues(rot, maxRot, medRot, 3, (self.cuttingElements[i].rotSpeed/3), dt, self.cuttingElements[i].lift);
            else
               self.cuttingElements[i].lift = true;
            end;

            setRotation(self.cuttingElements[i].index, unpack(newRot));
            
           
        end;
        
    
		if self.Mower and not self.wasToFast then
               			
				if self.cuttingElements[1].onGround then
					local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
					
					Utils.updateMeadowArea(x, z, x1, z1, x2, z2);
				end
				if self.cuttingElements[2].onGround then
					local x,y,z = getWorldTranslation(self.cuttingAreas[2].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[2].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[2].height);
					
					Utils.updateMeadowArea(x, z, x1, z1, x2, z2);
				end
				if self.cuttingElements[3].onGround then
					local x,y,z = getWorldTranslation(self.cuttingAreas[3].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[3].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[3].height);
					
					Utils.updateMeadowArea(x, z, x1, z1, x2, z2);
				end
			
			    if not self.mowerSoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.mowerSound, self.mowerSoundPitchOffset);
                playSample(self.mowerSound, 0, self.mowerSoundVolume, 0);
                self.mowerSoundEnabled = true;
            end;

            

        else
            if self.mowerSoundEnabled then
                stopSample(self.mowerSound);
                self.mowerSoundEnabled = false;
            end;
		end  
			
		if self.swath  then
			area1 = 0
			area2 = 0
			area3 = 0
			if self.cuttingElements[1].onGround then
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				area1 = Utils.updateFruitCutLongArea(FruitUtil.FRUITTYPE_GRASS, x, z, x1, z1, x2, z2, 0)
			end
				
			if self.cuttingElements[2].onGround then
				local x,y,z = getWorldTranslation(self.cuttingAreas[2].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[2].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[2].height);
				area2 = Utils.updateFruitCutLongArea(FruitUtil.FRUITTYPE_GRASS, x, z, x1, z1, x2, z2, 0)
			end
				
			if self.cuttingElements[3].onGround then
				local x,y,z = getWorldTranslation(self.cuttingAreas[3].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[3].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[3].height);
				area3 = Utils.updateFruitCutLongArea(FruitUtil.FRUITTYPE_GRASS, x, z, x1, z1, x2, z2, 0)
			end
				
		        local x,y,z = getWorldTranslation(self.cuttingAreas[4].start);
		        local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[4].width);
		        local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[4].height);
				value = area1 + area2 + area3
				Utils.updateFruitWindrowArea(FruitUtil.FRUITTYPE_GRASS, x, z, x1, z1, x2, z2, value, true)
				
				for i=1, self.numWalzen do 
					if self.cuttingElements[i+1].onGround then
						rotate(self.walzen[i].index,self.walzen[i].speed/-30*dt,0,0);
					end
				end
		end

          
            
    end;




   


function BigM1:draw()


 

    if self.wasToFast then
        g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), "2", InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL2)), 0.07+0.022, 0.019+0.029);
    end;

    if self.allDown then
        g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(self.keys.transport))..": in Transportposition")
    else
        g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(self.keys.transport))..": in Arbeitsposition")
    end;
    if self.cuttingElements[2].isDown then


        if self.Mower then
            g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(self.keys.maehen))..": Maehwerke stoppen");
            if self.swath then
                g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(self.keys.schwaden))..": Schwader abschalten");
            else
                g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(self.keys.schwaden))..": Schwader anschalten");
            end;
        else
            g_currentMission:addExtraPrintText("Taste "..string.upper(string.char(self.keys.maehen))..": Maehwerke starten");
        end;
    end;
 end 
 
function BigM1:onLeave() 

        

   

    
	
end;

function BigM1:delete()

    if self.mowerSound ~= nil then

    end;
 
end;

function BigM1:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BigM1:onEnter()
end;